/*********************************************
* Autor:
*********************************************/

#include "cc1101.h"
#include "mega16.h"
#include "pauza.h"
#include "uart.h"

unsigned char
ccxxx0_Read( unsigned char addr )
{
  unsigned char x;

  PORTB &= ~( 1 << CC_CSN );

  while ( PINB & ( 1 << CC_SO ) ) ;

  SPDR = ( addr | 0x80 );
  while ( !( SPSR & ( 1 << SPIF ) ) ) ;
  x = SPDR;			// ocisti ga

  SPDR = 0;
  while ( !( SPSR & ( 1 << SPIF ) ) ) ;
  x = SPDR;

  PORTB |= ( 1 << CC_CSN );

  return x;
}

unsigned char
ccxxx0_Write( unsigned char addr, unsigned char dat )
{
  unsigned char x;

  PORTB &= ~( 1 << CC_CSN );

  while ( PINB & ( 1 << CC_SO ) ) ;

  SPDR = addr;
  while ( !( SPSR & ( 1 << SPIF ) ) ) ;
  x = SPDR;			// ocisti ga

  SPDR = dat;
  while ( !( SPSR & ( 1 << SPIF ) ) ) ;
  x = SPDR;

  PORTB |= ( 1 << CC_CSN );

  return x;
}

unsigned char
ccxxx0_Strobe( unsigned char addr )
{
  unsigned char x;

  PORTB &= ~( 1 << CC_CSN );

  while ( PINB & ( 1 << CC_SO ) ) ;

  SPDR = addr;
  while ( !( SPSR & ( 1 << SPIF ) ) ) ;
  x = SPDR;

  PORTB |= ( 1 << CC_CSN );

  return x;
}

void
ccxxx0_ReadBurst( unsigned char addr, unsigned char *dataPtr,
    unsigned int dataCount )
{
  unsigned char x;

  PORTB &= ~( 1 << CC_CSN );

  while ( PINB & ( 1 << CC_SO ) ) ;

  SPDR = ( addr | 0xc0 );
  while ( !( SPSR & ( 1 << SPIF ) ) ) ;
  x = SPDR;			// ocisti ga

  while ( dataCount )
  {
    SPDR = 0;
    while ( !( SPSR & ( 1 << SPIF ) ) ) ;

    *dataPtr++ = SPDR;
    dataCount--;
  }

  PORTB |= ( 1 << CC_CSN );
}

void
ccxxx0_WriteBurst( unsigned char addr, unsigned char *dataPtr,
    unsigned int dataCount )
{
  unsigned char x;

  PORTB &= ~( 1 << CC_CSN );

  while ( PINB & ( 1 << CC_SO ) ) ;

  SPDR = addr | 0x40;
  while ( !( SPSR & ( 1 << SPIF ) ) ) ;
  x = SPDR;			// ocisti ga

  while ( dataCount )
  {
    SPDR = *dataPtr++;
    while ( !( SPSR & ( 1 << SPIF ) ) ) ;

    dataCount--;
  }

  PORTB |= ( 1 << CC_CSN );
}

void
ccxxx0_PowerOnReset(  )
{
  unsigned char x;

  PORTB |= ( 1 << CC_CSN );
  delay_us( 1 );
  PORTB &= ~( 1 << CC_CSN );
  delay_us( 1 );
  PORTB |= ( 1 << CC_CSN );
  delay_us( 41 );

  PORTB &= ~( 1 << CC_CSN );

  while ( PINB & ( 1 << CC_SO ) ) ;

  delay_us( 50 );		// PAUZA KOJA PO TEORIJI NE TREBA

  SPDR = CCxxx0_SRES;
  while ( !( SPSR & ( 1 << SPIF ) ) ) ;
  x = SPDR;			// ocisti ga

  while ( PINB & ( 1 << CC_SO ) ) ;

  delay_us( 50 );		// PAUZA KOJA PO TEORIJI NE TREBA

  PORTB |= ( 1 << CC_CSN );
}

void
ccxxx0_Setup( const RF_SETTINGS * settings )
{
  // Write register settings
  ccxxx0_Write( CCxxx0_FSCTRL1, settings->FSCTRL1 );
  ccxxx0_Write( CCxxx0_FSCTRL0, settings->FSCTRL0 );
  ccxxx0_Write( CCxxx0_FREQ2, settings->FREQ2 );
  ccxxx0_Write( CCxxx0_FREQ1, settings->FREQ1 );
  ccxxx0_Write( CCxxx0_FREQ0, settings->FREQ0 );
  ccxxx0_Write( CCxxx0_MDMCFG4, settings->MDMCFG4 );
  ccxxx0_Write( CCxxx0_MDMCFG3, settings->MDMCFG3 );
  ccxxx0_Write( CCxxx0_MDMCFG2, settings->MDMCFG2 );
  ccxxx0_Write( CCxxx0_MDMCFG1, settings->MDMCFG1 );
  ccxxx0_Write( CCxxx0_MDMCFG0, settings->MDMCFG0 );
  ccxxx0_Write( CCxxx0_CHANNR, settings->CHANNR );
  ccxxx0_Write( CCxxx0_DEVIATN, settings->DEVIATN );
  ccxxx0_Write( CCxxx0_FREND1, settings->FREND1 );
  ccxxx0_Write( CCxxx0_FREND0, settings->FREND0 );
  ccxxx0_Write( CCxxx0_MCSM0, settings->MCSM0 );
  ccxxx0_Write( CCxxx0_FOCCFG, settings->FOCCFG );
  ccxxx0_Write( CCxxx0_BSCFG, settings->BSCFG );
  ccxxx0_Write( CCxxx0_AGCCTRL2, settings->AGCCTRL2 );
  ccxxx0_Write( CCxxx0_AGCCTRL1, settings->AGCCTRL1 );
  ccxxx0_Write( CCxxx0_AGCCTRL0, settings->AGCCTRL0 );
  ccxxx0_Write( CCxxx0_FSCAL3, settings->FSCAL3 );
  ccxxx0_Write( CCxxx0_FSCAL2, settings->FSCAL2 );
  ccxxx0_Write( CCxxx0_FSCAL1, settings->FSCAL1 );
  ccxxx0_Write( CCxxx0_FSCAL0, settings->FSCAL0 );
  ccxxx0_Write( CCxxx0_FSTEST, settings->FSTEST );
  ccxxx0_Write( CCxxx0_TEST2, settings->TEST2 );
  ccxxx0_Write( CCxxx0_TEST1, settings->TEST1 );
  ccxxx0_Write( CCxxx0_TEST0, settings->TEST0 );
  ccxxx0_Write( CCxxx0_IOCFG2, settings->IOCFG2 );
  ccxxx0_Write( CCxxx0_IOCFG0, settings->IOCFG0 );
  ccxxx0_Write( CCxxx0_PKTCTRL1, settings->PKTCTRL1 );
  ccxxx0_Write( CCxxx0_PKTCTRL0, settings->PKTCTRL0 );
  ccxxx0_Write( CCxxx0_ADDR, settings->ADDR );
  ccxxx0_Write( CCxxx0_PKTLEN, settings->PKTLEN );
}
