/*********************************************
* mega16.c - source fajl
* Razne stvarcice bitne uC
* Autor: Muris Pucic Trax (www.elektronika.ba)
*********************************************/

#include <avr/io.h>

#include "mega16.h"

/*****
	Init ATMega mikrokontrolera.
*****/
void
ATMEGA_Init( void )
{
  // Podesimo Port C (LED i mozda jos nesto)
  DDRC = 0 b00011111;		// iiiooooo
  PORTC = 0;			// all leds off

  DDRA = 0xff;			// diode LQI indikator
  PORTA = 0;			// all off leds

  // Set baud rate
  UBRRL = ( uint8_t ) UART_BAUD_CALC;	// Load lower 8-bits of the baud rate 
					// value into the low byte of the
					// UBRR register
  UBRRH = ( uint8_t ) ( UART_BAUD_CALC >> 8 );	// Load upper 8-bits of the
						// baud rate value into the
						// high byte of the UBRR
						// register
  // Enable receiver and transmitter; dont enable RX interrupt
  UCSRB = ( 1 << RXEN ) | ( 1 << TXEN );	// |(1<<RXCIE);
  // Asynchronous 8N1
  UCSRC |= ( 1 << URSEL ) | ( 1 << UCSZ0 ) | ( 1 << UCSZ1 );	// Use 8-bit
								// character
								// sizes

  // SPI setup
  DDRB &= ~( 1 << SPIDI );	// set port B SPI data input to input
  DDRB |= ( 1 << SPICLK );	// set port B SPI clock to output
  DDRB |= ( 1 << SPIDO );	// set port B SPI data out to output
  DDRB |= ( 1 << SPICS );	// set port B SPI chip select to output
  DDRB |= ( 1 << PAN );		// set port B PA AMP control pin to output
  DDRB &= ~( 1 << CC_GDO0 );	// set port B packet received pin to input
  PORTC &= ~( 1 << CC_GDO0 );	// pullup off, resetujmo taj bit

  SPCR = ( 1 << SPE ) | ( 1 << MSTR ) | ( 1 << SPR1 ) | ( 1 << SPR0 );	
  // | (1 << SPI2X) ;// | (1 << SPR1) ;// | (1 << SPR0);
  SPSR = 0x00;

  PORTB |= ( 1 << SPICS );	// set chip select to high (CC is NOT
				// selected)
  PORTB &= ~( 1 << SPIDO );	// data out =0
  PORTB |= ( 1 << SPICLK );	// clock out =1
  PORTB |= ( 1 << PAN );	// disable power amp
}
