/*********************************************
* MyModem2.h - header fajl
* Main app stuff
* Autor: Muris Pucic Trax (www.elektronika.ba)
*********************************************/

// Chipcon
// Product = CC1101
// Chip version = A   (VERSION = 0x04)
// Crystal accuracy = 10 ppm
// X-tal frequency = 26 MHz
// RF output power = 10 dBm
// RX filterbandwidth = 58.035714 kHz
// Deviation = 5 kHz
// Datarate = 1.199484 kBaud
// Modulation = (1) 2-GFSK
// Manchester enable = (0) Manchester disabled
// RF Frequency = 900.092102 MHz
// Channel spacing = 199.951172 kHz
// Channel number = 159
// Optimization = -
// Sync mode = (3) 30/32 sync word bits detected
// Format of RX/TX data = (0) Normal mode, use FIFOs for RX and TX
// CRC operation = (1) CRC calculation in TX and CRC check in RX enabled
// Forward Error Correction = (0) FEC disabled
// Length configuration = (1) Variable length packets, packet length configured by the first received byte after sync word.
// Packetlength = 255
// Preamble count = (2)  4 bytes
// Append status = 1
// Address check = (0) No address check
// FIFO autoflush = 0
// Device address = 0
// GDO0 signal selection = ( 6) Asserts when sync word has been sent / received, and de-asserts at the end of the packet
// GDO2 signal selection = (41) CHIP_RDY
RF_SETTINGS   rfSettings = {
  0x06,				// FSCTRL1 Frequency synthesizer control.
  0x00,				// FSCTRL0 Frequency synthesizer control.
  0x21,				// FREQ2 Frequency control word, high byte.
  0x65,				// FREQ1 Frequency control word, middle byte.
  0x6A,				// FREQ0 Frequency control word, low byte.
  0xF5,				// MDMCFG4 Modem configuration.
  0x83,				// MDMCFG3 Modem configuration.
  0x13,				// MDMCFG2 Modem configuration.
  0x22,				// MDMCFG1 Modem configuration.
  0xF8,				// MDMCFG0 Modem configuration.
  0x9F,				// CHANNR Channel number.
  0x15,				// DEVIATN Modem deviation setting (when FSK
				// modulation is enabled).
  0x56,				// FREND1 Front end RX configuration.
  0x10,				// FREND0 Front end RX configuration.
  0x18,				// MCSM0 Main Radio Control State Machine
				// configuration.
  0x16,				// FOCCFG Frequency Offset Compensation
				// Configuration.
  0x6C,				// BSCFG Bit synchronization Configuration.
  0x03,				// AGCCTRL2 AGC control.
  0x40,				// AGCCTRL1 AGC control.
  0x91,				// AGCCTRL0 AGC control.
  0xE9,				// FSCAL3 Frequency synthesizer calibration.
  0x2A,				// FSCAL2 Frequency synthesizer calibration.
  0x00,				// FSCAL1 Frequency synthesizer calibration.
  0x1F,				// FSCAL0 Frequency synthesizer calibration.
  0x59,				// FSTEST Frequency synthesizer calibration.
  0x81,				// TEST2 Various test settings.
  0x35,				// TEST1 Various test settings.
  0x09,				// TEST0 Various test settings.
  0x2E,				// IOCFG2 GDO2 output pin configuration.
  0x07,				// IOCFG0 GDO0 output pin configuration.
				// Refer to SmartRF Studio User Manual for
				// detailed pseudo register explanation.
  0x05,				// PKTCTRL1 Packet automation control.
  0x04,				// PKTCTRL0 Packet automation control.
  77,				// ADDR Device address. 'M'
  0x05				// PKTLEN Packet length.
};

// PATABLE (+10 dBm output power)
unsigned char paTable[] = {
  0xC0				// , 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0
      // 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03
};
